/*
    Copyright (c) 2011-2012 Ternary Labs. All Rights Reserved.

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in
    all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    THE SOFTWARE.
*//*
# Websequencediagrams.com
participant abc.com
participant "iFrame proxy xyz.com"
participant "iFrame proxy abc.com"
participant "iFrame xyz.com"
abc.com->iFrame proxy xyz.com: postMessage(data, targetOrigin)
note left of "iFrame proxy xyz.com": Set url fragment and change size
iFrame proxy xyz.com->iFrame proxy xyz.com: onResize Event
note right of "iFrame proxy xyz.com": read url fragment
iFrame proxy xyz.com->iFrame xyz.com: forwardMessageEvent(event)
iFrame xyz.com->iFrame proxy abc.com: postMessage(data, targetOrigin)
note right of "iFrame proxy abc.com": Set url fragment and change size
iFrame proxy abc.com->iFrame proxy abc.com: onResize Event
note right of "iFrame proxy abc.com": read url fragment
iFrame proxy abc.com->abc.com: forwardMessageEvent(event)
*//* Simple JavaScript Inheritance
 * By John Resig http://ejohn.org/
 * MIT Licensed.
 */// Inspired by base2 and Prototype
(function(){var e=!1,t=/xyz/.test(function(){xyz})?/\b_super\b/:/.*/;this.Class=function(){};Class.extend=function(n){function o(){!e&&this.init&&this.init.apply(this,arguments)}var r=this.prototype;e=!0;var i=new this;e=!1;for(var s in n)i[s]=typeof n[s]=="function"&&typeof r[s]=="function"&&t.test(n[s])?function(e,t){return function(){var n=this._super;this._super=r[e];var i=t.apply(this,arguments);this._super=n;return i}}(s,n[s]):n[s];o.prototype=i;o.prototype.constructor=o;o.extend=arguments.callee;return o}})();(function(e){"use strict";var t={trace:function(t){e.console!==undefined&&e.console.log("Porthole: "+t)},error:function(t){e.console!==undefined&&e.console.error("Porthole: "+t)}};t.WindowProxy=function(){};t.WindowProxy.prototype={post:function(e,t){},addEventListener:function(e){},removeEventListener:function(e){}};t.WindowProxyBase=Class.extend({init:function(t){t===undefined&&(t="");this.targetWindowName=t;this.origin=e.location.protocol+"//"+e.location.host;this.eventListeners=[]},getTargetWindowName:function(){return this.targetWindowName},getOrigin:function(){return this.origin},getTargetWindow:function(){return t.WindowProxy.getTargetWindow(this.targetWindowName)},post:function(t,n){n===undefined&&(n="*");this.dispatchMessage({data:t,sourceOrigin:this.getOrigin(),targetOrigin:n,sourceWindowName:e.name,targetWindowName:this.getTargetWindowName()})},addEventListener:function(e){this.eventListeners.push(e);return e},removeEventListener:function(e){var t;try{t=this.eventListeners.indexOf(e);this.eventListeners.splice(t,1)}catch(n){this.eventListeners=[]}},dispatchEvent:function(e){var t;for(t=0;t<this.eventListeners.length;t++)try{this.eventListeners[t](e)}catch(n){}}});t.WindowProxyLegacy=t.WindowProxyBase.extend({init:function(e,t){this._super(t);if(e===null){this.proxyIFrameElement=null;throw new Error("proxyIFrameUrl can't be null")}this.proxyIFrameName=this.targetWindowName+"ProxyIFrame";this.proxyIFrameLocation=e;this.proxyIFrameElement=this.createIFrameProxy()},createIFrameProxy:function(){var e=document.createElement("iframe");e.setAttribute("id",this.proxyIFrameName);e.setAttribute("name",this.proxyIFrameName);e.setAttribute("src",this.proxyIFrameLocation);e.setAttribute("frameBorder","1");e.setAttribute("scrolling","auto");e.setAttribute("width",30);e.setAttribute("height",30);e.setAttribute("style","position: absolute; left: -100px; top:0px;");e.style.setAttribute&&e.style.setAttribute("cssText","position: absolute; left: -100px; top:0px;");document.body.appendChild(e);return e},dispatchMessage:function(n){var r=e.encodeURIComponent;if(this.proxyIFrameElement){var i=this.proxyIFrameLocation+"#"+r(t.WindowProxy.serialize(n));this.proxyIFrameElement.setAttribute("src",i);this.proxyIFrameElement.height=this.proxyIFrameElement.height>50?50:100}}});t.WindowProxyHTML5=t.WindowProxyBase.extend({init:function(e,t){this._super(t);this.eventListenerCallback=null},dispatchMessage:function(e){this.getTargetWindow().postMessage(t.WindowProxy.serialize(e),e.targetOrigin)},addEventListener:function(t){if(this.eventListeners.length===0){var n=this;this.eventListenerCallback=function(e){n.eventListener(n,e)};e.addEventListener?e.addEventListener("message",this.eventListenerCallback,!1):e.attachEvent&&e.attachEvent("onmessage",this.eventListenerCallback)}return this._super(t)},removeEventListener:function(t){this._super(t);if(this.eventListeners.length===0){e.addEventListener?e.removeEventListener("message",this.eventListenerCallback):e.attachEvent&&e.detachEvent("onmessage",this.eventListenerCallback);this.eventListenerCallback=null}},eventListener:function(e,n){var r=t.WindowProxy.unserialize(n.data);r&&(e.targetWindowName==""||r.sourceWindowName==e.targetWindowName)&&e.dispatchEvent(new t.MessageEvent(r.data,n.origin,e))}});if(typeof e.postMessage=="undefined"){t.trace("Using legacy browser support");t.WindowProxy=t.WindowProxyLegacy.extend({})}else{t.trace("Using built-in browser support");t.WindowProxy=t.WindowProxyHTML5.extend({})}t.WindowProxy.serialize=function(e){if(typeof JSON=="undefined")throw new Error("Porthole serialization depends on JSON!");return JSON.stringify(e)};t.WindowProxy.unserialize=function(e){if(typeof JSON=="undefined")throw new Error("Porthole unserialization dependens on JSON!");try{var t=JSON.parse(e)}catch(n){return!1}return t};t.WindowProxy.getTargetWindow=function(t){return t===""?top:t==="top"||t==="parent"?e[t]:parent.frames[t]};t.MessageEvent=function(t,n,r){this.data=t;this.origin=n;this.source=r};t.WindowProxyDispatcher={forwardMessageEvent:function(n){var r,i=e.decodeURIComponent,s,o;if(document.location.hash.length>0){r=t.WindowProxy.unserialize(i(document.location.hash.substr(1)));s=t.WindowProxy.getTargetWindow(r.targetWindowName);o=t.WindowProxyDispatcher.findWindowProxyObjectInWindow(s,r.sourceWindowName);o?o.origin===r.targetOrigin||r.targetOrigin==="*"?o.dispatchEvent(new t.MessageEvent(r.data,r.sourceOrigin,o)):t.error("Target origin "+o.origin+" does not match desired target of "+r.targetOrigin):t.error("Could not find window proxy object on the target window")}},findWindowProxyObjectInWindow:function(e,t){var n;e.RuntimeObject&&(e=e.RuntimeObject());if(e)for(n in e)if(e.hasOwnProperty(n))try{if(e[n]!==null&&typeof e[n]=="object"&&e[n]instanceof e.window.Porthole.WindowProxy&&e[n].getTargetWindowName()===t)return e[n]}catch(r){}return null},start:function(){e.addEventListener?e.addEventListener("resize",t.WindowProxyDispatcher.forwardMessageEvent,!1):e.attachEvent&&e.postMessage!=="undefined"?e.attachEvent("onresize",t.WindowProxyDispatcher.forwardMessageEvent):document.body.attachEvent?e.attachEvent("onresize",t.WindowProxyDispatcher.forwardMessageEvent):t.error("Cannot attach resize event")}};typeof e.exports!="undefined"?e.exports.Porthole=t:e.Porthole=t})(this);